﻿using Microsoft.Xaml.Behaviors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Input;

namespace FLY.Integrated.UI.Client
{

    public class ResetAction2:IDisposable
    {
        public object obj;
        public string propertyname;
        public bool pressIsTrue;
        UIElement uIElement;
        public ResetAction2(UIElement uIElement, object obj, string propertyname, bool pressIsTrue=true)
        {
            this.uIElement = uIElement;
            this.obj = obj;
            this.propertyname = propertyname;
            this.pressIsTrue = pressIsTrue;


            uIElement.PreviewMouseDown += UIElement_PreviewMouseDown;
            uIElement.PreviewTouchDown += UIElement_PreviewTouchDown;
            uIElement.PreviewMouseUp += UIElement_PreviewMouseUp;
            uIElement.PreviewTouchUp += UIElement_PreviewTouchUp;
        }

        public void Dispose()
        {
            uIElement.PreviewMouseDown -= UIElement_PreviewMouseDown;
            uIElement.PreviewTouchDown -= UIElement_PreviewTouchDown;
            uIElement.PreviewMouseUp -= UIElement_PreviewMouseUp;
            uIElement.PreviewTouchUp -= UIElement_PreviewTouchUp;
        }

        private void UIElement_PreviewTouchUp(object sender, TouchEventArgs e)
        {
            Up();
        }

        private void UIElement_PreviewMouseUp(object sender, MouseButtonEventArgs e)
        {
            Up();
        }
        private void UIElement_PreviewTouchDown(object sender, TouchEventArgs e)
        {
            Down();
        }
        private void UIElement_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            Down();
        }



        void Down()
        {
            if (pressIsTrue)
                Misc.PropertiesManager.SetValue(obj, propertyname, true);
            else
                Misc.PropertiesManager.SetValue(obj, propertyname, false);
        }
        void Up()
        {
            if (pressIsTrue)
                Misc.PropertiesManager.SetValue(obj, propertyname, false);
            else
                Misc.PropertiesManager.SetValue(obj, propertyname, true);
        }
    }

    public class ResetBehavior : Behavior<UIElement> 
    {
        public System.Windows.Data.Binding Binding { get; set; }
        ResetAction2 resetAction = null;
        public ResetBehavior() 
        {
        }

        protected override void OnAttached()
        {
            base.OnAttached();
            DependencyObject dobj = AssociatedObject;
            if (!(dobj is UIElement))
                return;

            if (Binding != null && Binding.Path != null)
            {
                var obj = FLY.ControlLibrary.COMMON.GetDataContext(dobj);
                if (Binding.Source != null)
                    obj = Binding.Source;

                resetAction = new ResetAction2(dobj as UIElement, obj, Binding.Path.Path);
            }
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            if (resetAction != null)
            {
                resetAction.Dispose();
                resetAction = null;
            }

        }
    }
}
