﻿using FLY.Integrated.UI.Client.UIModule;
using Misc;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Integrated.UI.Client
{
    [JsonObject(MemberSerialization.OptIn)]
    public class SysParam : INotifyPropertyChanged
    {
        static SysParam current;
        public static SysParam Current
        {
            get
            {
                if (current == null)
                {
                    current = new SysParam();
                }
                return current;
            }
        }

        #region 属性，成员变量的代理

        [JsonProperty]
        [JsonConverter(typeof(IPEndPointJsonConverter))]
        public IPEndPoint ServerEP { get; set; }

        [JsonProperty]
        public IbcCtrlGraphParams GraphParams { get; } = new IbcCtrlGraphParams();


        string file_path = "integrateParam.json";
        #endregion

        public SysParam()
        {
            ServerEP = Misc.StringConverter.ToIPEndPoint("127.0.0.1:20003");
            if (!Load())
                Save();

        }

        public bool Load()
        {
            if (!File.Exists(file_path)) 
            {
                return false;
            }
            try
            {
                string json = File.ReadAllText(file_path);
                Newtonsoft.Json.JsonConvert.PopulateObject(json, this);
            }
            catch {
                return false;
            }
            return true;
        }
        public void Save()
        {
            string json = Newtonsoft.Json.JsonConvert.SerializeObject(this);
            File.WriteAllText(file_path, json);
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
