﻿using FLY.Integrated.Client;
using FLY.Integrated.Common;
using FLY.OBJComponents.Client;
using FLY.OBJComponents.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Integrated.UI.Client
{
    public class TDGage
    {
        public IntegratedSystemServiceClient integratedSystemServiceClient;
        public WarningServiceClient mWarningService;
        public BufferWindow<FlyData_WarningHistory> mWarningReasonWindow;


        SysParam sysparam;
        public TDGage()
        {
            sysparam = SysParam.Current;
            integratedSystemServiceClient = new FLY.Integrated.Client.IntegratedSystemServiceClient();
            mWarningService = new OBJComponents.Client.WarningServiceClient(FLY.Integrated.OBJ_INTERFACE.OBJ_INTERFACE.WARNING_OBJ_ID);

            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                sysparam.ServerEP,
                integratedSystemServiceClient.GetIDs());

            FObjBase.FObjSys.Current.Connect_to_Another_OBJSys(
                sysparam.ServerEP,
                mWarningService.GetIDs());

            //创建窗口观察 报警原因列表
            mWarningReasonWindow = new OBJComponents.Client.BufferWindow<OBJComponents.Common.FlyData_WarningHistory>(mWarningService.ReasonList, 100);
        }

        
        static TDGage current;
        public static TDGage Current
        {
            get
            {
                if (current == null)
                {
                    current = new TDGage();
                }
                return current;
            }
        }
    }


}
