﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Integrated.UI.Client.UIModule
{
    /// <summary>
    /// UcRotaryPanel.xaml 的交互逻辑
    /// </summary>
    public partial class UcRotaryPanel : UserControl
    {

        FLY.Integrated.Client.IntegratedSystemServiceClient integratedSystemServiceClient;
        FLY.OBJComponents.Client.SetPLCUpdatePlan setPlan;
        List<ResetAction2> resetActions = new List<ResetAction2>();
        public UcRotaryPanel()
        {
            InitializeComponent();
        }
        public void Init()
        {
            integratedSystemServiceClient = TDGage.Current.integratedSystemServiceClient;
            this.DataContext = integratedSystemServiceClient.Accessory;

            //注册属性更新计划
            setPlan= new SetPLCUpdatePlan(
                 integratedSystemServiceClient.PLCos,
                 integratedSystemServiceClient.Accessory,
                 new string[] {
                     "RotaryFreq",
                     "RotaryFreqSet",
                     "IsRotaryFreqChanged",
                    
                    "IsRotaryOn",
                    "IsRotaryOrg",

                    "IsRotaryForw",
                    "IsRotaryBackw",
                    "IsRotaryForwLimit",
                    "IsRotaryForwTurn",
                    "IsRotaryOrgSign",
                    "IsRotaryBackwLimit",
                    "IsRotaryBackwTurn"
                 });

            resetActions.Add(new ResetAction2(btnRotateForw, integratedSystemServiceClient.Accessory, "RotaryForw"));
            resetActions.Add(new ResetAction2(btnRotateBackw, integratedSystemServiceClient.Accessory, "RotaryBackw"));
            resetActions.Add(new ResetAction2(btnRotateOn, integratedSystemServiceClient.Accessory, "RotaryOn"));
            resetActions.Add(new ResetAction2(btnRotateOrg, integratedSystemServiceClient.Accessory, "RotaryOrg"));

        }

        private void btnFreqClick(object sender, RoutedEventArgs e)
        {
            WdFreq w = new WdFreq();
            w.Init();
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();

        }
    }

    public class UIModule_RotaryPanel : FLY.UI.Module.IUIModule
    {
        /// <summary>
        /// 控件标题
        /// 它的值取决于culture
        /// </summary>
        public string Title
        {
            get
            {
                return "综合.旋转调节";
            }
        }

        /// <summary>
        /// 控件
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetComponent(int id)
        {
            UcRotaryPanel graph = new UcRotaryPanel();
            graph.Init();
            return graph;
        }

        /// <summary>
        /// 控件缩略图，用于编辑界面时，大致看看
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetThumbnail(int id)
        {
            return new System.Windows.Controls.Grid();
        }


        /// <summary>
        /// 给出全部控件ID, 控件自行删除没有的参数
        /// </summary>
        /// <param name="IDs"></param>
        public void MatchParam(int[] IDs)
        {
        }
    }
}
