﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FLY.Integrated.UI.Client
{
    /// <summary>
    /// Window_Frequency.xaml 的交互逻辑
    /// </summary>
    public partial class WdFreq : FLY.ControlLibrary.WindowBigClose
    {
        FLY.Integrated.Client.IntegratedSystemServiceClient integratedSystemServiceClient;
        FLY.OBJComponents.Client.SetPLCUpdatePlan setPlan;

        public WdFreq()
        {
            InitializeComponent();
            this.Closed += WdFreq_Closed;
        }

        private void WdFreq_Closed(object sender, EventArgs e)
        {
            setPlan.Dispose();
        }

        public void Init()
        {
            integratedSystemServiceClient = TDGage.Current.integratedSystemServiceClient;
            this.DataContext = integratedSystemServiceClient.Accessory;

            integratedSystemServiceClient = TDGage.Current.integratedSystemServiceClient;
            this.DataContext = integratedSystemServiceClient.Accessory;

            //注册属性更新计划
            setPlan = new SetPLCUpdatePlan(
                 integratedSystemServiceClient.PLCos,
                 integratedSystemServiceClient.Accessory,
                 new string[] {
                     "RotaryFreqSet"
                 });
        }

        private void btnPlusClick(object sender, RoutedEventArgs e)
        {
            if (integratedSystemServiceClient.Accessory.RotaryFreqSet < 50.0)
                integratedSystemServiceClient.Accessory.RotaryFreqSet += 0.1f;
        }

        private void btnMinusClick(object sender, RoutedEventArgs e)
        {
            if (integratedSystemServiceClient.Accessory.RotaryFreqSet >= 0.1)
                integratedSystemServiceClient.Accessory.RotaryFreqSet -= 0.1f;
        }
    }
}
