﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FLY.Integrated.UI.Client.UIModule
{
    /// <summary>
    /// Window_Frequency.xaml 的交互逻辑
    /// </summary>
    public partial class WdVelocity : FLY.ControlLibrary.WindowBigClose
    {
        FLY.Integrated.Client.IntegratedSystemServiceClient integratedSystemServiceClient;
        FLY.OBJComponents.Client.SetPLCUpdatePlan setPlan;

        public WdVelocity()
        {
            InitializeComponent();
            this.Closed += WdVelocity_Closed;
        }

        private void WdVelocity_Closed(object sender, EventArgs e)
        {
            setPlan.Dispose();
        }

        public void Init() 
        {
            integratedSystemServiceClient = TDGage.Current.integratedSystemServiceClient;
            this.DataContext = integratedSystemServiceClient.Accessory;

            integratedSystemServiceClient = TDGage.Current.integratedSystemServiceClient;
            this.DataContext = integratedSystemServiceClient.Accessory;
            //注册属性更新计划
            setPlan = new SetPLCUpdatePlan(
                 integratedSystemServiceClient.PLCos,
                 integratedSystemServiceClient.Accessory,
                 new string[] {
                     "TractionVelocitySet"
                 });
        }

        private void btnPlusClick(object sender, RoutedEventArgs e)
        {
            if (integratedSystemServiceClient.Accessory.TractionVelocitySet < 999.0)
                integratedSystemServiceClient.Accessory.TractionVelocitySet += 0.1f;
        }

        private void btnMinusClick(object sender, RoutedEventArgs e)
        {
            if (integratedSystemServiceClient.Accessory.TractionVelocitySet >= 0.1)
                integratedSystemServiceClient.Accessory.TractionVelocitySet -= 0.1f;
        }
    }
}
