﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Weight.UI.Client.UIModule
{
    /// <summary>
    /// UcThickness.xaml 的交互逻辑
    /// </summary>
    public partial class UcThickness : UserControl
    {

        FLY.Weight.Client.WeightSystemClient mWeighterCsService;

        SetPLCUpdatePlan setPlan_accessory;

        public UcThickness()
        {
            InitializeComponent();
        }
        public void Init(int id)
        {
            mWeighterCsService = TDGage.Current.mWeighterCsService;
            this.DataContext = mWeighterCsService;

            setPlan_accessory = new SetPLCUpdatePlan(
                mWeighterCsService.PLCos,
                mWeighterCsService.Accessory,
                new string[] {
                        "TotalFilmWidth",
                        "IsRimNoRecycle",
                        "RimWidth",
                        "ActFilmWidth",
                        "SetThickness",
                        "TargetVelocity",
                        "CurrentVelocity"
                });
        }


        private void button_thickness_Click(object sender, RoutedEventArgs e)
        {
            Window_Thickness w = new Window_Thickness();
            if (mWeighterCsService.Items.Count() < 1)
                return;

            w.SetThickness = (int)mWeighterCsService.Accessory.SetThickness;
            w.FilmWidth = (int)mWeighterCsService.Accessory.TotalFilmWidth;
            w.RimWidth = (int)mWeighterCsService.Accessory.RimWidth;
            w.IsRimNoRecycle = mWeighterCsService.Accessory.IsRimNoRecycle;



            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);

            if (w.ShowDialog() == true)
            {
                mWeighterCsService.Accessory.SetThickness = w.SetThickness;
                mWeighterCsService.Accessory.TotalFilmWidth = w.FilmWidth;
                mWeighterCsService.Accessory.RimWidth = w.RimWidth;
                mWeighterCsService.Accessory.IsRimNoRecycle = w.IsRimNoRecycle;

                FLY.ControlLibrary.Window_Tip.Show("", "厚度参数设置成功", TimeSpan.FromSeconds(2));
            }
        }

    }
    public class UIModule_Thickness : FLY.UI.Module.IUIModule
    {
        /// <summary>
        /// 控件标题
        /// 它的值取决于culture
        /// </summary>
        public string Title
        {
            get
            {
                return "称重厚度";
            }
        }

        /// <summary>
        /// 控件
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetComponent(int id)
        {
            UcThickness graph = new UcThickness();
            graph.Init(id);
            return graph;
        }

        /// <summary>
        /// 控件缩略图，用于编辑界面时，大致看看
        /// 创建时，需要给它唯一ID，让加载自己的数据
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public FrameworkElement GetThumbnail(int id)
        {
            return new System.Windows.Controls.Grid();
        }


        /// <summary>
        /// 给出全部控件ID, 控件自行删除没有的参数
        /// </summary>
        /// <param name="IDs"></param>
        public void MatchParam(int[] IDs)
        {
        }
    }
}
