﻿using FLY.OBJComponents.Client;
using FLY.Winder.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Winder.UI.Client.UIModule
{
    /// <summary>
    /// Page_Main.xaml 的交互逻辑
    /// </summary>
    public partial class Page_Main : Page
    {
        FLY.Winder.Client.WinderSystemServiceClient winderSystem;

        SetPLCUpdatePlan setPlan_accessory;
        SetPLCUpdatePlan[] setPlan_winders = new SetPLCUpdatePlan[2];
        List<ResetAction2> resetActions = new List<ResetAction2>();
        public Page_Main()
        {
            InitializeComponent();
        }
        public void Init(int id)
        {
            winderSystem = TDGage.Current.mWinderSystem;
            this.DataContext = winderSystem;
            grid_winder.DataContext = winderSystem;

            resetActions.Add(new ResetAction2(btnT1On, winderSystem.Accessory, "IsTraction1OnSet"));
            resetActions.Add(new ResetAction2(btnT2On, winderSystem.Accessory, "IsTraction2OnSet"));
            resetActions.Add(new ResetAction2(btnWind0On, winderSystem.Items[0], "IsOnSet"));
            resetActions.Add(new ResetAction2(btnWind1On, winderSystem.Items[1], "IsOnSet"));

            resetActions.Add(new ResetAction2(button_ron, winderSystem.Accessory, "RotaryOn"));
            resetActions.Add(new ResetAction2(button_rorg, winderSystem.Accessory, "RotaryOrg"));

            resetActions.Add(new ResetAction2(button_clear0, winderSystem.Items[0], "MeasureReset"));
            resetActions.Add(new ResetAction2(button_clear1, winderSystem.Items[1], "MeasureReset"));
            //注册属性更新计划
            setPlan_accessory = new SetPLCUpdatePlan(
                winderSystem.PLCos,
                 winderSystem.Accessory,
                 new string[] {
                    "VelocitySet",
                    "IsVelocityChanged",
                    "Velocity",

                    "RotaryFreqSet",
                    "IsRotaryFreqChanged",
                    "RotaryCurrent",
                    "RotaryFreq",
                    "IsRotaryOn",
                    "IsRotaryOrg",

                    "IsRotaryForw",
                    "IsRotaryBackw",
                    "IsRotaryForwLimit",
                    "IsRotaryForwTurn",
                    "IsRotaryOrgSign",
                    "IsRotaryBackwLimit",
                    "IsRotaryBackwTurn",

                    "Traction1Current",
                    "IsTraction1On",
                    "IsTraction2Manual",
                    "Traction2TensionKgSet",
                    "Traction2TensionKg",
                    "Traction2Current",
                    "IsTraction2Manual",
                    "IsTraction2On"
                 });

            for (int i = 0; i < 2; i++)
            {
                setPlan_winders[i] = new SetPLCUpdatePlan(
                    winderSystem.PLCos,
                    winderSystem.Items[i],
                    new string[] {
                        "MeasureLenSet",
                        "MeasurePreWarning",
                        "MeasureLen",
                        "MeasureStop",

                        "TensionKgSet",
                        "TensionKg",
                        "Current",
                        "IsManual",
                        "IsOn"
                    });
            }
        }
        private void button_v_set_Click(object sender, RoutedEventArgs e)
        {
            Window_Velocity w = new Window_Velocity();
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void button_manual_Click(object sender, RoutedEventArgs e)
        {
            WdManual w = new WdManual();
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void button_freq_Click(object sender, RoutedEventArgs e)
        {
            Window_Freq w = new Window_Freq();
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void button_measure_Click(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            WinderInsideOutside item = (WinderInsideOutside)(button.Tag);
            Window_Measure w = new Window_Measure();
            w.Init((int)(item.MeasureLenSet), (int)(item.MeasurePreWarning));
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            if (w.ShowDialog() == true)
            {
                item.MeasureLenSet = w.viewmodel.MeasureLenSet;
                item.MeasurePreWarning = w.viewmodel.MeasurePreWarning;
            }
        }

    }


}
