﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FLY.Winder.UI.Client.UIModule
{
    /// <summary>
    /// CenterWinder.xaml 的交互逻辑
    /// </summary>
    public partial class UcCenterWinder : UserControl
    {
        FLY.Winder.Client.WinderSystemServiceClient winderSystem;

        SetPLCUpdatePlan[] setPlan_winders = new SetPLCUpdatePlan[2];
        List<ResetAction2> resetActions = new List<ResetAction2>();

        public UcCenterWinder()
        {
            InitializeComponent();
        }
        public void Init(int id) 
        {
            winderSystem = TDGage.Current.mWinderSystem;
            this.DataContext = winderSystem;
            resetActions.Add(new ResetAction2(btnSurface0, winderSystem.Items[0], "IsSurfaceWindSet"));
            resetActions.Add(new ResetAction2(btnCenter0, winderSystem.Items[0], "IsCenterWindSet"));
            resetActions.Add(new ResetAction2(btnCs0, winderSystem.Items[0], "IsCsWindSet"));
            resetActions.Add(new ResetAction2(btnSeparate0, winderSystem.Items[0], "EPRollerSeparateSet"));

            resetActions.Add(new ResetAction2(btnSurface1, winderSystem.Items[1], "IsSurfaceWindSet"));
            resetActions.Add(new ResetAction2(btnCenter1, winderSystem.Items[1], "IsCenterWindSet"));
            resetActions.Add(new ResetAction2(btnCs1, winderSystem.Items[1], "IsCsWindSet"));
            resetActions.Add(new ResetAction2(btnSeparate1, winderSystem.Items[1], "EPRollerSeparateSet"));

            //注册属性更新计划
            for (int i = 0; i < 2; i++)
            {
                setPlan_winders[i] = new SetPLCUpdatePlan(
                    winderSystem.PLCos,
                    winderSystem.Items[i],
                    new string[] {
                        "CenterTensionSet",
                        "CenterInitDia",
                        "IsCenterInitDiaNotify",
                        "CenterTaperSet",
                        "CenterTensionKg",
                        "CenterDia",
                        "EPInitPressure",
                        "EPTaperSet",
                        "EPAirPressure",
                        "IsEPRollerClosed",
                        "IsSurfaceWindGet",
                        "IsCenterWindGet",
                        "IsCsWindGet"
                    });
            }
            winderSystem.Items[0].PropertyChanged += Items0_PropertyChanged;
            winderSystem.Items[1].PropertyChanged += Items1_PropertyChanged;

        }

        private async void Items0_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "CenterInitDia")
            {
                if (winderSystem.IsInPushValue)
                    return;

                await Task.Delay(1000);//1s后触发通知
                winderSystem.Items[0].IsCenterInitDiaNotify = true;
            }
        }
        private async void Items1_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "CenterInitDia")
            {
                if (winderSystem.IsInPushValue)
                    return;

                await Task.Delay(1000);//1s后触发通知
                winderSystem.Items[1].IsCenterInitDiaNotify = true;
            }
        }
        private void UserControl_Unloaded(object sender, RoutedEventArgs e)
        {

        }
    }
}
