﻿using FLY.OBJComponents.Client;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace FLY.Winder.UI.Client.UIModule
{
    /// <summary>
    /// Window_Frequency.xaml 的交互逻辑
    /// </summary>
    public partial class WdManual : FLY.ControlLibrary.WindowBigClose
    {
        FLY.Winder.Client.WinderSystemServiceClient winderSystem;
        SetPLCUpdatePlan[] setPlan_winders = new SetPLCUpdatePlan[2];
        List<ResetAction2> resetActions = new List<ResetAction2>();
        public WdManual()
        {
            InitializeComponent();
            Init();
        }

        void Init() 
        {
            winderSystem = TDGage.Current.mWinderSystem;
            this.DataContext = winderSystem;
            resetActions.Add(new ResetAction2(btnTurn0, winderSystem.Items[0], "TurnoverInching"));
            resetActions.Add(new ResetAction2(btnOrg0, winderSystem.Items[0], "TurnoverOrg"));
            resetActions.Add(new ResetAction2(btnCut0, winderSystem.Items[0], "CuttingFilm"));
            resetActions.Add(new ResetAction2(btnArm0, winderSystem.Items[0], "PressureArmOffset"));
            resetActions.Add(new ResetAction2(btnTop0, winderSystem.Items[0], "PushRod"));

            resetActions.Add(new ResetAction2(btnTongClamp0, winderSystem.Items[0], "TongClamp"));
            resetActions.Add(new ResetAction2(btnTongLoosen0, winderSystem.Items[0], "TongLoosen"));
            resetActions.Add(new ResetAction2(btnTongUp0, winderSystem.Items[0], "TongUp"));
            resetActions.Add(new ResetAction2(btnTongDown0, winderSystem.Items[0], "TongDown"));
            resetActions.Add(new ResetAction2(btnTongIn0, winderSystem.Items[0], "TongIn"));
            resetActions.Add(new ResetAction2(btnTongOut0, winderSystem.Items[0], "TongOut"));




            resetActions.Add(new ResetAction2(btnTurn1, winderSystem.Items[1], "TurnoverInching"));
            resetActions.Add(new ResetAction2(btnOrg1, winderSystem.Items[1], "TurnoverOrg")); 
            resetActions.Add(new ResetAction2(btnCut1, winderSystem.Items[1], "CuttingFilm"));
            resetActions.Add(new ResetAction2(btnArm1, winderSystem.Items[1], "PressureArmOffset"));
            resetActions.Add(new ResetAction2(btnTop1, winderSystem.Items[1], "PushRod"));

            resetActions.Add(new ResetAction2(btnTongClamp1, winderSystem.Items[1], "TongClamp"));
            resetActions.Add(new ResetAction2(btnTongLoosen1, winderSystem.Items[1], "TongLoosen"));
            resetActions.Add(new ResetAction2(btnTongUp1, winderSystem.Items[1], "TongUp"));
            resetActions.Add(new ResetAction2(btnTongDown1, winderSystem.Items[1], "TongDown"));
            resetActions.Add(new ResetAction2(btnTongIn1, winderSystem.Items[1], "TongIn"));
            resetActions.Add(new ResetAction2(btnTongOut1, winderSystem.Items[1], "TongOut"));

            //IsTongAuto
            //注册属性更新计划
            for (int i = 0; i < 2; i++)
            {
                setPlan_winders[i] = new SetPLCUpdatePlan(
                    winderSystem.PLCos,
                    winderSystem.Items[i],
                    new string[] {
                        "IsTongAuto",
                        "TurnoverInching",
                        "CuttingFilm",
                        "TurnoverOrg",
                        "PressureArmOffset",
                        "PushRod",
                        "TongLoosen",
                        "TongUp",
                        "TongDown",
                        "TongIn",
                        "TongOut" });
            }
        }

        private void WindowBigClose_Unloaded(object sender, RoutedEventArgs e)
        {
            for (int i = 0; i < 2; i++)
            {
                setPlan_winders[i].Dispose();
            }
        }
    }


}
