﻿using System.ComponentModel;

namespace XXX.Common
{
    public class WinderAccessory : INotifyPropertyChanged
    {
        public WinderAccessory()
        {

        }
        #region 辅助代码生成
        /// <summary>
        /// 速度系数
        /// </summary>
        [Description("速度系数")]
        public float VelocityFactor{ get; set; }

        /// <summary>
        /// 牵引直径
        /// </summary>
        [Description("牵引直径")]
        public float TractionDiameter{ get; set; }

        /// <summary>
        /// 牵引速比
        /// </summary>
        [Description("牵引速比")]
        public float TractionVRatio{ get; set; }

        /// <summary>
        /// 牵引速度(内部）
        /// </summary>
        [Description("牵引速度(内部）")]
        public float TractionVelocityInner{ get; set; }

        /// <summary>
        /// 牵引额定频率
        /// </summary>
        [Description("牵引额定频率")]
        public float TractionDefaultFreq{ get; set; }

        /// <summary>
        /// 旋转额定频率
        /// </summary>
        [Description("旋转额定频率")]
        public float RotationDefaultFreq{ get; set; }

        /// <summary>
        /// 牵引速度
        /// </summary>
        [Description("牵引速度")]
        public float TractionVelocity{ get; set; }

        /// <summary>
        /// 牵引速度设置
        /// </summary>
        [Description("牵引速度设置")]
        public float TractionVelocitySet{ get; set; }

        /// <summary>
        /// 主牵引运行指示
        /// </summary>
        [Description("主牵引运行指示")]
        public bool IsTractionOn{ get; set; }

        /// <summary>
        /// 主牵引开
        /// </summary>
        [Description("主牵引开")]
        public bool TractionOn{ get; set; }

        /// <summary>
        /// 气垫辊风机运行指示
        /// </summary>
        [Description("气垫辊风机运行指示")]
        public bool IsAirCushionOn{ get; set; }

        /// <summary>
        /// 气垫辊风机开
        /// </summary>
        [Description("气垫辊风机开")]
        public bool AirCushionOn{ get; set; }

        /// <summary>
        /// 旋转塔正转指示
        /// </summary>
        [Description("旋转塔正转指示")]
        public bool IsRotaryForw{ get; set; }

        /// <summary>
        /// 旋转塔反转指示
        /// </summary>
        [Description("旋转塔反转指示")]
        public bool IsRotaryBackw{ get; set; }

        /// <summary>
        /// 旋转塔正转
        /// </summary>
        [Description("旋转塔正转")]
        public bool RotaryForw{ get; set; }

        /// <summary>
        /// 旋转塔反转
        /// </summary>
        [Description("旋转塔反转")]
        public bool RotaryBackw{ get; set; }

        /// <summary>
        /// 旋转塔正向机械限位
        /// </summary>
        [Description("旋转塔正向机械限位")]
        public bool IsRotaryForwLimit{ get; set; }

        /// <summary>
        /// 旋转塔正转换向限位
        /// </summary>
        [Description("旋转塔正转换向限位")]
        public bool IsRotaryForwTurn{ get; set; }

        /// <summary>
        /// 旋转塔复位原点限位
        /// </summary>
        [Description("旋转塔复位原点限位")]
        public bool IsRotaryOrgSign{ get; set; }

        /// <summary>
        /// 旋转塔反转换向限位
        /// </summary>
        [Description("旋转塔反转换向限位")]
        public bool IsRotaryBackwTurn{ get; set; }

        /// <summary>
        /// 旋转塔反向机械限位
        /// </summary>
        [Description("旋转塔反向机械限位")]
        public bool IsRotaryBackwLimit{ get; set; }

        /// <summary>
        /// 旋转塔电机频率设定(Hz)
        /// </summary>
        [Description("旋转塔电机频率设定(Hz)")]
        public float RotaryFreqSet{ get; set; }

        /// <summary>
        /// 旋转塔电机频率显示(Hz)
        /// </summary>
        [Description("旋转塔电机频率显示(Hz)")]
        public float RotaryFreq{ get; set; }

        /// <summary>
        /// 旋转塔复位指示
        /// </summary>
        [Description("旋转塔复位指示")]
        public bool IsRotaryOrg{ get; set; }

        /// <summary>
        /// 旋转塔复位(┷）
        /// </summary>
        [Description("旋转塔复位(┷）")]
        public bool RotaryOrg{ get; set; }

        /// <summary>
        /// 旋转塔开启指示
        /// </summary>
        [Description("旋转塔开启指示")]
        public bool IsRotaryOn{ get; set; }

        /// <summary>
        /// 旋转塔开启(┷）
        /// </summary>
        [Description("旋转塔开启(┷）")]
        public bool RotaryOn{ get; set; }

        /// <summary>
        /// 故障复位
        /// </summary>
        [Description("故障复位")]
        public bool AlarmReset{ get; set; }

        /// <summary>
        /// 旋转变频故障报警 (ON)
        /// </summary>
        [Description("旋转变频故障报警")]
        [IsError()]
        public bool IsRotationMotorError{ get; set; }

        /// <summary>
        /// 牵引变频故障报警 (ON)
        /// </summary>
        [Description("牵引变频故障报警")]
        [IsError()]
        public bool IsTractionMotorError{ get; set; }

        /// <summary>
        /// 旋转变频通讯报警 (ON)
        /// </summary>
        [Description("旋转变频通讯报警")]
        [IsError()]
        public bool IsRotationCommError2{ get; set; }

        /// <summary>
        /// 牵引变频通讯报警 (ON)
        /// </summary>
        [Description("牵引变频通讯报警")]
        [IsError()]
        public bool IsTractionCommError2{ get; set; }

        /// <summary>
        /// 急停开启报警 (ON)
        /// </summary>
        [Description("急停开启报警")]
        [IsError()]
        public bool IsEmergencyStopError{ get; set; }

        /// <summary>
        /// 旋转正转极限报警 (ON)
        /// </summary>
        [Description("旋转正转极限报警")]
        [IsError()]
        public bool IsRotationForwLimitError{ get; set; }

        /// <summary>
        /// 旋转反转极限报警 (ON)
        /// </summary>
        [Description("旋转反转极限报警")]
        [IsError()]
        public bool IsRotationBackwLimitError{ get; set; }

        #endregion
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
