﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Autogen_WS
{
    public class WS_ItemInfo
    {
        /// <summary>
        /// 属性描述
        /// </summary>
        public string propDescription;
        /// <summary>
        /// 属性名
        /// </summary>
        public string propName;
        /// <summary>
        /// 数据类型， bool, float, uint16, int16, uint32, int32
        /// </summary>
        public string typeName;
        /// <summary>
        /// 放大
        /// </summary>
        public double scale = 1;
        /// <summary>
        /// 报警
        /// </summary>
        public bool isError = false;
        /// <summary>
        ///报警触发条件 true=ON时触发， false=OFF时触发
        /// </summary>
        public bool trigger = true;
        /// <summary>
        /// plc 序号
        /// </summary>
        public int plcIndex = 0;
        /// <summary>
        /// 寄存器类型 0,1,3,4
        /// </summary>
        public string regType;
        /// <summary>
        /// 地址
        /// </summary>
        public int mbAddr = -1;


        /// <summary>
        /// 对象名
        /// </summary>
        public string objectName;

        public WS_ItemInfo()
        { }

        public WS_ItemInfo Clone()
        {
            WS_ItemInfo ii = new WS_ItemInfo();
            ii.propDescription = propDescription;
            ii.propName = propName;
            ii.typeName = typeName;
            ii.scale = scale;
            ii.isError = isError;
            ii.trigger = trigger;

            ii.plcIndex = plcIndex;
            ii.regType = regType;
            ii.mbAddr = mbAddr;

            ii.objectName = objectName;
            return ii;
        }

        public string GetPropertyType()//转为C#类型，只有bool 与 float
        {
            if (typeName == "bool")
                return "bool";
            else
                return "float";
        }
    }
}
